import { clientTypeArray, openTypeArray } from '@/utils/searchArray'
import {
  NForm,
  NFormItem,
  NInput,
  NSpace,
  NButton,
  useMessage,
  NRadioGroup,
  NRadio,
  NSelect
} from 'naive-ui'
import { defineComponent, onMounted, PropType, reactive, ref } from 'vue'
import { leaveCategorySave, leaveCategoryUpdate } from '../../api'
export default defineComponent({
  name: 'role-operation',
  props: {
    type: {
      type: String,
      default: 'add'
    },
    data: {
      type: Object as PropType<any>,
      default: () => {}
    }
  },
  emits: ['close', 'getList'],
  setup(props, { slots, attrs, emit }) {
    const forms = reactive({
      clientType: null,
      name: null,
      remark: null
    })
    const btnLoading = ref(false)

    const formsRef = ref()
    const message = useMessage()

    const onSubmit = async () => {
      formsRef.value.validate(async (error: any) => {
        if (error) return false
        try {
          btnLoading.value = true
          if (props.type === 'add') {
            await leaveCategorySave({ ...forms })
            message.success('添加成功')
          } else if (props.type === 'edit') {
            await leaveCategoryUpdate({ ...forms, id: props.data.id })
            message.success('修改成功')
          }

          emit('close')
          emit('getList')
        } catch (e: any) {
          console.log(e, 'e')
        }
        btnLoading.value = false
      })
    }

    onMounted(async () => {
      if (props.type === 'edit') {
        const data = props.data
        forms.clientType = data.clientType
        forms.name = data.name
        forms.remark = data.remark
      }
    })

    return () => (
      <div style="background: #fff; padding-top: 12px">
        <NForm model={forms} ref={formsRef} label-placement="left" label-width="auto">
          <NFormItem
            label="客户端类型"
            path="clientType"
            rule={[
              {
                required: true,
                message: '请输入客户端类型'
              }
            ]}
          >
            <NSelect
              placeholder="请输入客户端类型"
              v-model:value={forms.clientType}
              options={clientTypeArray}
              clearable
            />
          </NFormItem>
          <NFormItem
            label="类型名称"
            path="name"
            rule={[
              {
                required: true,
                message: '请输入类型名称'
              }
            ]}
          >
            <NInput
              v-model:value={forms.name}
              placeholder="请输入类型名称"
              clearable
              maxlength={100}
            ></NInput>
          </NFormItem>
          <NFormItem label="备注" path="remark">
            <NInput
              v-model:value={forms.remark}
              maxlength={180}
              type="textarea"
              rows={3}
              placeholder="请输入备注"
              clearable
            />
          </NFormItem>
        </NForm>

        <NSpace justify="end">
          <NButton type="default" onClick={() => emit('close')}>
            取消
          </NButton>
          <NButton type="primary" onClick={onSubmit} loading={btnLoading.value}>
            保存
          </NButton>
        </NSpace>
      </div>
    )
  }
})
